<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: CPP Utils</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">CPP Utils </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This directory contains a wealth of C++ classes that have been found useful when working in C++ in conjunction with the ESP-IDF. The classes have been documented using <code>doxygen</code> so one can run a doxygen processor over them to create the user guides and programming references.</p>
<h1>Compiling the C++ classes</h1>
<p>The C++ classes found here exist as an ESP-IDF component. To build the classes and then use them in your project perform the following steps:</p>
<ol type="1">
<li>Create an ESP-IDF project.</li>
<li>Create a directory called <code>components</code> in the root of your ESP-IDF project.</li>
<li>Copy this directory (<code>cpp_utils</code>) into your new <code>components</code> directory. The result will be <code>&lt;project&gt;/components/cpp_utils/&lt;files&gt;</code>.</li>
<li>In your ESP-IDF project build as normal.</li>
</ol>
<p>The C++ classes will be compiled and available to be used in your own code.</p>
<h1>Adding a main function</h1>
<p>When working with C++, your calling function should also be written in C++. Consider replacing your <code>main.c</code> with the following <code>main.cpp</code> file:</p>
<div class="fragment"><div class="line">extern &quot;C&quot; {</div><div class="line">   void app_main();</div><div class="line">}</div><div class="line"></div><div class="line">void app_main() {</div><div class="line">   // Your code goes here</div><div class="line">}</div></div><!-- fragment --><p>The way to read the above is that we are defining a global function called <code>app_main</code> but we are saying that its external linkage (i.e. how it is found and called) is using the C language convention. However, since the source file is <code>main.cpp</code> and hence compiled by the C++ compiler, you can utilize C++ classes and language features within and, since it has C linkage, it will satisfy the ESP-IDF environment as the entry point into your own code.</p>
<h2>BLE Functions</h2>
<p>The Bluetooth BLE functions are only compiled if Bluetooth is enabled in <code>make menuconfig</code>. This is primarily because the ESP-IDF build system has chosen to only compile the underlying BLE functions if Bluetooth is enabled.</p>
<h2>Building the Documentation</h2>
<p>The code is commented using the Doxygen tags. As such we can run Doxygen to generate the data. I use <code>doxywizard</code> using the <code>Doxyfile</code> located in this directory.</p>
<h2>Building the Arduino libraries</h2>
<p>Some of the classes in this package also have applicability in an Arduino environment. A <code>Makefile</code> called <code>Makefile.arduino</code> is provided to build the libraries. For example:</p>
<div class="fragment"><div class="line">$ make -f Makefile.arduino</div></div><!-- fragment --><p>The results of this will be ZIP files found in the <code>Arduino</code> directory relative to this one. Targets include:</p>
<ul>
<li><code>build_ble</code> - Build the BLE libraries. See also: <a class="el" href="md_ArduinoBLE.html">Arduino BLE Support</a> . </li>
</ul>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
